export declare class ColorItem {
    readonly red: number;
    readonly green: number;
    readonly blue: number;
    readonly alpha: number;
    readonly colorCode: string;
    readonly namedColor: string;
    constructor(red: number, green: number, blue: number, alpha?: number);
    /**
     * @param colorCode HEX or RGBA code
     * @param namedColor name of color
     */
    constructor(colorCode: string, namedColor?: string);
    toString(): string;
    withAlphaPercent(a: number): ColorItem;
    private static parseRgb;
    private static rgb;
}
export default class Colors {
    static rgba(red: number, green: number, blue: number, alpha?: number): ColorItem;
    static parse(color: string): ColorItem;
    static black: ColorItem;
    static silver: ColorItem;
    static gray: ColorItem;
    static white: ColorItem;
    static maroon: ColorItem;
    static red: ColorItem;
    static purple: ColorItem;
    static fuchsia: ColorItem;
    static green: ColorItem;
    static lime: ColorItem;
    static olive: ColorItem;
    static yellow: ColorItem;
    static navy: ColorItem;
    static blue: ColorItem;
    static teal: ColorItem;
    static aqua: ColorItem;
    static orange: ColorItem;
    static aliceBlue: ColorItem;
    static antiqueWhite: ColorItem;
    static aquaMarine: ColorItem;
    static azure: ColorItem;
    static beige: ColorItem;
    static bisque: ColorItem;
    static blanchedAlmond: ColorItem;
    static blueViolet: ColorItem;
    static brown: ColorItem;
    static burlyWood: ColorItem;
    static cadetBlue: ColorItem;
    static chartReuse: ColorItem;
    static chocolate: ColorItem;
    static coral: ColorItem;
    static cornFlowerBlue: ColorItem;
    static cornSilk: ColorItem;
    static crimson: ColorItem;
    static cyan: ColorItem;
    static darkBlue: ColorItem;
    static darkCyan: ColorItem;
    static darkGoldenRod: ColorItem;
    static darkGray: ColorItem;
    static darkGreen: ColorItem;
    static darkGrey: ColorItem;
    static darkKhaki: ColorItem;
    static darkMagenta: ColorItem;
    static darkOliveGreen: ColorItem;
    static darkOrange: ColorItem;
    static darkOrchid: ColorItem;
    static darkRed: ColorItem;
    static darkSalmon: ColorItem;
    static darkSeaGreen: ColorItem;
    static darkSlateBlue: ColorItem;
    static darkSlateGray: ColorItem;
    static darkSlateGrey: ColorItem;
    static darkTurquoise: ColorItem;
    static darkViolet: ColorItem;
    static deepPink: ColorItem;
    static deepSkyBlue: ColorItem;
    static dimGray: ColorItem;
    static dimGrey: ColorItem;
    static dodgerBlue: ColorItem;
    static fireBrick: ColorItem;
    static floralWhite: ColorItem;
    static forestGreen: ColorItem;
    static gainsboro: ColorItem;
    static ghostWhite: ColorItem;
    static gold: ColorItem;
    static goldenRod: ColorItem;
    static greenYellow: ColorItem;
    static grey: ColorItem;
    static honeyDew: ColorItem;
    static hotPink: ColorItem;
    static indianRed: ColorItem;
    static indigo: ColorItem;
    static ivory: ColorItem;
    static khaki: ColorItem;
    static lavender: ColorItem;
    static lavenderBlush: ColorItem;
    static lawnGreen: ColorItem;
    static lemonChiffon: ColorItem;
    static lightBlue: ColorItem;
    static lightCoral: ColorItem;
    static lightCyan: ColorItem;
    static lightGoldenRodYellow: ColorItem;
    static lightGray: ColorItem;
    static lightGreen: ColorItem;
    static lightGrey: ColorItem;
    static lightPink: ColorItem;
    static lightSalmon: ColorItem;
    static lightSeaGreen: ColorItem;
    static lightSkyBlue: ColorItem;
    static lightSlateGray: ColorItem;
    static lightSlateGrey: ColorItem;
    static lightSteelBlue: ColorItem;
    static lightYellow: ColorItem;
    static limeGreen: ColorItem;
    static linen: ColorItem;
    static magenta: ColorItem;
    static mediumAquaMarine: ColorItem;
    static mediumBlue: ColorItem;
    static mediumOrchid: ColorItem;
    static mediumPurple: ColorItem;
    static mediumSeaGreen: ColorItem;
    static mediumSlateBlue: ColorItem;
    static mediumSpringGreen: ColorItem;
    static mediumTurquoise: ColorItem;
    static mediumVioletred: ColorItem;
    static midNightBlue: ColorItem;
    static mintCream: ColorItem;
    static mistyRose: ColorItem;
    static moccasin: ColorItem;
    static navajoWhite: ColorItem;
    static oldLace: ColorItem;
    static oliveDrab: ColorItem;
    static orangeRed: ColorItem;
    static orchid: ColorItem;
    static paleGoldenRod: ColorItem;
    static paleGreen: ColorItem;
    static paleTurquoise: ColorItem;
    static paleVioletRed: ColorItem;
    static papayaWhip: ColorItem;
    static peachPuff: ColorItem;
    static peru: ColorItem;
    static pink: ColorItem;
    static plum: ColorItem;
    static powderBlue: ColorItem;
    static rosyBrown: ColorItem;
    static royalBlue: ColorItem;
    static saddleBrown: ColorItem;
    static salmon: ColorItem;
    static sandyBrown: ColorItem;
    static seaGreen: ColorItem;
    static seaShell: ColorItem;
    static sienna: ColorItem;
    static skyBlue: ColorItem;
    static slateBlue: ColorItem;
    static slateGray: ColorItem;
    static slateGrey: ColorItem;
    static snow: ColorItem;
    static springGreen: ColorItem;
    static steelBlue: ColorItem;
    static tan: ColorItem;
    static thistle: ColorItem;
    static tomato: ColorItem;
    static turquoise: ColorItem;
    static violet: ColorItem;
    static wheat: ColorItem;
    static whiteSmoke: ColorItem;
    static yellowGreen: ColorItem;
    static rebeccaPurple: ColorItem;
    static transparent: ColorItem;
}
//# sourceMappingURL=Colors.d.ts.map