(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.StringHelper = void 0;
    class StringHelper {
        static fromCamelToHyphen(input) {
            return input.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
        }
        static fromCamelToUnderscore(input) {
            return input.replace(/([a-z])([A-Z])/g, "$1_$2").toLowerCase();
        }
        static fromCamelToPascal(input) {
            return input[0].toUpperCase() + input.substr(1);
        }
        static fromHyphenToCamel(input) {
            return input.replace(/-([a-z])/g, (g) => g[1].toUpperCase());
        }
        static fromUnderscoreToCamel(input) {
            return input.replace(/\_([a-z])/g, (g) => g[1].toUpperCase());
        }
        static fromPascalToCamel(input) {
            return input[0].toLowerCase() + input.substr(1);
        }
    }
    exports.StringHelper = StringHelper;
});
//# sourceMappingURL=StringHelper.js.map