var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../App", "../di/DISingleton", "../di/Inject"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const App_1 = require("../App");
    const DISingleton_1 = require("../di/DISingleton");
    const Inject_1 = require("../di/Inject");
    let CacheService = class CacheService {
        constructor(app) {
            this.app = app;
            this.cache = {};
        }
        remove(key) {
            const v = this.cache[key];
            if (v) {
                this.clear(v);
                return v.value;
            }
            return null;
        }
        getOrCreate(key, task) {
            return __awaiter(this, void 0, void 0, function* () {
                const c = this.cache[key] || (this.cache[key] = {
                    key,
                    finalTTL: 3600
                });
                if (!c.value) {
                    c.value = task(c);
                }
                let v = null;
                try {
                    v = yield c.value;
                }
                catch (e) {
                    this.clear(c);
                    throw e;
                }
                if (c.ttlSeconds !== undefined) {
                    if (typeof c.ttlSeconds === "number") {
                        c.finalTTL = c.ttlSeconds;
                    }
                    else {
                        c.finalTTL = c.ttlSeconds(v);
                    }
                }
                if (c.timeout) {
                    clearTimeout(c.timeout);
                }
                if (c.finalTTL) {
                    this.cache[key] = c;
                    c.timeout = setTimeout(() => {
                        c.timeout = 0;
                        this.clear(c);
                    }, c.finalTTL * 1000);
                }
                else {
                    // this is the case where we do not want to store
                    this.clear(c);
                }
                return yield c.value;
            });
        }
        clear(ci) {
            if (ci.timeout) {
                clearTimeout(ci.timeout);
                ci.timeout = 0;
            }
            this.cache[ci.key] = null;
            delete this.cache[ci.key];
        }
    };
    CacheService = __decorate([
        DISingleton_1.default(),
        __param(0, Inject_1.Inject),
        __metadata("design:paramtypes", [App_1.App])
    ], CacheService);
    exports.default = CacheService;
});
//# sourceMappingURL=CacheService.js.map