var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../di/DISingleton"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ObjectReference = void 0;
    const DISingleton_1 = require("../di/DISingleton");
    class ObjectReference {
        constructor(key, value) {
            this.key = key;
            this.value = value;
        }
    }
    exports.ObjectReference = ObjectReference;
    let ReferenceService = class ReferenceService {
        constructor() {
            this.cache = {};
            this.id = 1;
        }
        get(key) {
            return this.cache[key];
        }
        put(item, ttl = 60) {
            const key = `k${this.id++}`;
            const r = new ObjectReference(key, item);
            r.consume = () => {
                delete this.cache[key];
                if (r.timeout) {
                    clearTimeout(r.timeout);
                }
                return r.value;
            };
            r.timeout = setTimeout(() => {
                r.timeout = 0;
                r.consume();
            }, ttl * 1000);
            this.cache[key] = r;
            return r;
        }
    };
    ReferenceService = __decorate([
        DISingleton_1.default()
    ], ReferenceService);
    exports.default = ReferenceService;
});
//# sourceMappingURL=ReferenceService.js.map