var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../../App", "../../../../core/AtomBinder", "../../../../core/BindableProperty", "../../../../di/Inject", "../../../../view-model/AtomViewModel", "../../../../web/services/WindowService"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MovieListViewModel = void 0;
    const App_1 = require("../../../../App");
    const AtomBinder_1 = require("../../../../core/AtomBinder");
    const BindableProperty_1 = require("../../../../core/BindableProperty");
    const Inject_1 = require("../../../../di/Inject");
    const AtomViewModel_1 = require("../../../../view-model/AtomViewModel");
    const WindowService_1 = require("../../../../web/services/WindowService");
    let MovieListViewModel = class MovieListViewModel extends AtomViewModel_1.AtomViewModel {
        constructor(app, windowService) {
            super(app);
            this.windowService = windowService;
            this.movies = [
                { label: "First", category: "None" },
                { label: "True Lies", category: "Action" },
                { label: "Jurassic Park", category: "Adventure" },
                { label: "Big", category: "Kids" },
                { label: "Inception", category: "Suspense" },
                { label: "Last", category: "None" },
            ];
        }
        get errorSelectedMovie() {
            return this.selectedMovie ? "" : "Please select any movie";
        }
        onItemClick(data) {
            this.selectedMovie = data;
        }
        onDelete(data) {
            return __awaiter(this, void 0, void 0, function* () {
                if (!(yield this.windowService.confirm("Are you sure you want to delete?", "Confirm"))) {
                    return;
                }
                AtomBinder_1.AtomBinder.removeItem(this.movies, data);
                yield this.windowService.alert("Movie deleted successfully.");
            });
        }
    };
    __decorate([
        BindableProperty_1.BindableProperty,
        __metadata("design:type", Array)
    ], MovieListViewModel.prototype, "movies", void 0);
    __decorate([
        BindableProperty_1.BindableProperty,
        __metadata("design:type", Object)
    ], MovieListViewModel.prototype, "selectedMovie", void 0);
    __decorate([
        AtomViewModel_1.Validate,
        __metadata("design:type", String),
        __metadata("design:paramtypes", [])
    ], MovieListViewModel.prototype, "errorSelectedMovie", null);
    MovieListViewModel = __decorate([
        __param(0, Inject_1.Inject),
        __param(1, Inject_1.Inject),
        __metadata("design:paramtypes", [App_1.App,
            WindowService_1.WindowService])
    ], MovieListViewModel);
    exports.MovieListViewModel = MovieListViewModel;
});
//# sourceMappingURL=MovieListViewModel.js.map