var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../services/NavigationService", "../../controls/AtomTabbedPage", "../../WebApp"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TabApp = void 0;
    const NavigationService_1 = require("../../../services/NavigationService");
    const AtomTabbedPage_1 = require("../../controls/AtomTabbedPage");
    const WebApp_1 = require("../../WebApp");
    class TabApp extends WebApp_1.default {
        main() {
            const page = new AtomTabbedPage_1.AtomTabbedPage(this);
            this.root = page;
            setTimeout(() => __awaiter(this, void 0, void 0, function* () {
                const nav = this.resolve(NavigationService_1.NavigationService);
                yield nav.openPage("web-atoms-core/dist/web/samples/tabs/views/Page1", {
                    message: "Page 1"
                });
                yield nav.openPage("web-atoms-core/dist/web/samples/tabs/views/Page1", {
                    message: "Page 2"
                });
            }), 1000);
        }
    }
    exports.TabApp = TabApp;
});
//# sourceMappingURL=app.js.map