(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../core/Bind", "../../../core/XNode", "../../../services/NavigationService", "../../controls/AtomControl"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Bind_1 = require("../../../core/Bind");
    const XNode_1 = require("../../../core/XNode");
    const NavigationService_1 = require("../../../services/NavigationService");
    const AtomControl_1 = require("../../controls/AtomControl");
    class WindowSample extends AtomControl_1.AtomControl {
        create() {
            const ns = this.resolve(NavigationService_1.NavigationService);
            this.render(XNode_1.default.create("div", null,
                XNode_1.default.create("button", { eventClick: Bind_1.default.event(() => ns.alert("Alert")) }, "Alert"),
                XNode_1.default.create("button", { eventClick: Bind_1.default.event(() => ns.confirm("Confirm")) }, "Confirm")));
        }
    }
    exports.default = WindowSample;
});
//# sourceMappingURL=WindowSample.js.map