(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../core/Colors", "./AtomStyle"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Colors_1 = require("../../core/Colors");
    const AtomStyle_1 = require("./AtomStyle");
    class AtomNotificationStyle extends AtomStyle_1.AtomStyle {
        get root() {
            return {
                padding: "5px",
                borderRadius: "5px",
                border: "solid 1px lightgray",
                fontFamily: "Verdana, Geneva, sans-serif",
                fontSize: "16px",
                subclasses: {
                    ".error": {
                        borderColor: Colors_1.default.red,
                        color: Colors_1.default.red,
                    },
                    ".warning": {
                        backgroundColor: Colors_1.default.lightYellow
                    }
                }
            };
        }
    }
    exports.default = AtomNotificationStyle;
});
//# sourceMappingURL=AtomNotificationStyle.js.map