var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../App", "../../core/Colors", "../../di/Inject", "../../di/RegisterSingleton", "../../services/NavigationService", "../styles/AtomStyleSheet"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AtomTheme = void 0;
    const App_1 = require("../../App");
    const Colors_1 = require("../../core/Colors");
    const Inject_1 = require("../../di/Inject");
    const RegisterSingleton_1 = require("../../di/RegisterSingleton");
    const NavigationService_1 = require("../../services/NavigationService");
    const AtomStyleSheet_1 = require("../styles/AtomStyleSheet");
    let AtomTheme = class AtomTheme extends AtomStyleSheet_1.AtomStyleSheet {
        // public readonly window = this.createStyle(AtomWindow, AtomWindowStyle, "window");
        // public readonly popup = this.createNamedStyle(AtomPopupStyle, "popup");
        constructor(app, navigationService) {
            super(app, "atom-theme");
            this.navigationService = navigationService;
            this.bgColor = Colors_1.default.white;
            this.color = Colors_1.default.gray;
            this.hoverColor = Colors_1.default.lightGray;
            this.activeColor = Colors_1.default.lightBlue;
            this.selectedBgColor = Colors_1.default.blue;
            this.selectedColor = Colors_1.default.white;
            this.padding = 5;
            setTimeout(() => {
                window.addEventListener("resize", () => {
                    setTimeout(() => {
                        this.pushUpdate();
                    }, 10);
                });
                document.body.addEventListener("resize", () => {
                    setTimeout(() => {
                        this.pushUpdate();
                    }, 10);
                });
            }, 1000);
        }
    };
    AtomTheme = __decorate([
        RegisterSingleton_1.RegisterSingleton,
        __param(0, Inject_1.Inject),
        __param(1, Inject_1.Inject),
        __metadata("design:paramtypes", [App_1.App,
            NavigationService_1.NavigationService])
    ], AtomTheme);
    exports.AtomTheme = AtomTheme;
});
//# sourceMappingURL=AtomTheme.js.map