(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./AtomListBoxStyle"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AtomToggleButtonBarStyle = void 0;
    const AtomListBoxStyle_1 = require("./AtomListBoxStyle");
    class AtomToggleButtonBarStyle extends AtomListBoxStyle_1.AtomListBoxStyle {
        constructor() {
            super(...arguments);
            this.toggleColor = "blue";
        }
        get root() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomToggleButtonBarStyle, "root")), { display: "inline-block", paddingInlineStart: 0 });
        }
        get item() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomToggleButtonBarStyle, "item")), { borderRadius: 0, display: "inline-block", border: "1px solid", borderLeft: "none", color: this.toggleColor, borderColor: this.toggleColor, cursor: "pointer", subclasses: {
                    ":first-child": {
                        borderTopLeftRadius: `${this.padding || this.theme.padding}px`,
                        borderBottomLeftRadius: `${this.padding || this.theme.padding}px`,
                        borderTopRightRadius: 0,
                        borderBottomRightRadius: 0,
                        borderLeft: "1px solid"
                    },
                    ":last-child": {
                        borderTopLeftRadius: 0,
                        borderBottomLeftRadius: 0,
                        borderTopRightRadius: `${this.padding || this.theme.padding}px`,
                        borderBottomRightRadius: `${this.padding || this.theme.padding}px`
                    }
                } });
        }
        get selectedItem() {
            return Object.assign(Object.assign({}, this.getBaseProperty(AtomToggleButtonBarStyle, "selectedItem")), { borderRadius: 0, display: "inline-block", border: "1px solid", borderLeft: "none", borderColor: this.toggleColor, cursor: "pointer", subclasses: {
                    ":first-child": {
                        borderTopLeftRadius: `${this.padding || this.theme.padding}px`,
                        borderBottomLeftRadius: `${this.padding || this.theme.padding}px`,
                        borderTopRightRadius: 0,
                        borderBottomRightRadius: 0
                    },
                    ":last-child": {
                        borderTopLeftRadius: 0,
                        borderBottomLeftRadius: 0,
                        borderTopRightRadius: `${this.padding || this.theme.padding}px`,
                        borderBottomRightRadius: `${this.padding || this.theme.padding}px`
                    }
                } });
        }
    }
    exports.AtomToggleButtonBarStyle = AtomToggleButtonBarStyle;
});
//# sourceMappingURL=AtomToggleButtonBarStyle.js.map